# MS-Connector v1.3.0 Release vom 19.05.2022

Der MS-Connector implementiert eine Bridge zwischen dem österreichischen E-ID System und dem eIDAS Framework um ausländischen Benutzern eine Anmeldung am österreichischen Service-Providern zu ermöglichen.

### Änderungen in dieser Version

  - Mindestens Java 11 erforderlich
  - Erweitertes Identitätsmatching welches sowohl bestehende ZMR und ERnP Einträge berücksichtigt
  - Integration der vom BM.I übermittelten UX Templates in die Beispielkonfiguration
  - Bugfix
      - Fehler bei der Verarbeitung von leeren Attributewerten behoben
  - Akutalisierung von Drittherstellerbibliotheken
        - openSAML 4.0.1
        - EAAF-Components 1.3.2
        - SpringBoot 2.5.13
        - Spring-Framework 5.3.20
        - Apache CXF 3.5.2


### Durchführen eines Updates 

Nachfolgend finden Sie die erforderlichen Schritte für das Update eines bestehenden MS-specific eIDAS Connectors auf die aktuelle Version 1.3.0. Das vollständige Handbuch mit allen Konfigurationsparametern finden Sie im Releasepackage im Verzeichnis: _infos/handbook/_

### Ausgehend von einer bestehenden Version 1.2.x 

1. Stoppen Sie die *MS-Connector* Applikation und fertigen Sie eine Sicherungskopie Ihrer Applikation inklusive Konfiguration an

2. Entpacken Sie das Releasepacket *ms_specific_connector-1.3.0-dist.zip* in ein temporäres Verzeichnis welches in weiterer Folge __MsConnectorPackage__ bezeichnet wird.

3. Kopieren sie die Applikation __MsConnectorPackage__/ms_connector.war nach in das Applikationsverzeichnis ihres Applikationsservers

4. Update bestehender Dateien . Die nachfolgenden Dateien wurden geändert und erfordern eine Anpassung oder eine Übernahme dem Releasepacket, sofern die Anpassung nicht bereits durchgeführt wurde

   * Vollständige Übernahme: __MsConnectorPackage__/config/templates/other_login_method.html
   * Vollständige Übernahme: __MsConnectorPackage__/config/templates/residency.html
   * Vollständige Übernahme: __MsConnectorPackage__/config/properties/messages.properties
   * Vollständige Übernahme: __MsConnectorPackage__/config/properties/messages_de.properties
   * Vollständige Übernahme: __MsConnectorPackage__/config/keys/id_austria_truststore.jks

5. Neue Konfigurationsparameter

   Eine Beispielkonfiguration befindet sich in: __MsConnectorPackage__/config/default_config.properties

   - *ZMR Client*
     - ```eidas.ms.auth.eIDAS.zmrclient.endpoint```
     - ```eidas.ms.auth.eIDAS.zmrclient.ssl.keyStore.type```
     - ```eidas.ms.auth.eIDAS.zmrclient.ssl.keyStore.path```
     - ```eidas.ms.auth.eIDAS.zmrclient.ssl.keyStore.password```
     - ```eidas.ms.auth.eIDAS.zmrclient.ssl.key.alias```
     - ```eidas.ms.auth.eIDAS.zmrclient.ssl.key.password```
     - ```eidas.ms.auth.eIDAS.zmrclient.req.organisation.behoerdennr```
   - *ERnP Client*
     - ```eidas.ms.auth.eIDAS.ernpclient.endpoint```
     - ```eidas.ms.auth.eIDAS.ernpclient.ssl.keyStore.type```
     - ```eidas.ms.auth.eIDAS.ernpclient.ssl.keyStore.path```
     - ```eidas.ms.auth.eIDAS.ernpclient.ssl.keyStore.password```
     - ```eidas.ms.auth.eIDAS.ernpclient.ssl.key.alias```
     - ```eidas.ms.auth.eIDAS.ernpclient.ssl.key.password```
     - ```eidas.ms.auth.eIDAS.ernpclient.req.organisation.behoerdennr```
   - *ID Austria Client für Matching*
     - ```eidas.ms.modules.idaustriaclient.keystore.type```
     - ```eidas.ms.modules.idaustriaclient.keystore.path```
     - ```eidas.ms.modules.idaustriaclient.keystore.password```
     - ```eidas.ms.modules.idaustriaclient.metadata.sign.alias```
     - ```eidas.ms.modules.idaustriaclient.metadata.sign.password```
     - ```eidas.ms.modules.idaustriaclient.request.sign.alias```
     - ```eidas.ms.modules.idaustriaclient.request.sign.password```
     - ```eidas.ms.modules.idaustriaclient.response.encryption.alias```
     - ```eidas.ms.modules.idaustriaclient.response.encryption.password```
     - ```eidas.ms.modules.idaustriaclient.truststore.type```
     - ```eidas.ms.modules.idaustriaclient.truststore.path```
     - ```eidas.ms.modules.idaustriaclient.truststore.password```
     - ```eidas.ms.modules.idaustriaclient.idaustria.idp.entityId```

6. Neue optionale Konfigurationsparameter

   - *ZMR Client*
     - ```eidas.ms.auth.eIDAS.zmrclient.ssl.trustStore.type```
     - ```eidas.ms.auth.eIDAS.zmrclient.ssl.trustStore.path```
     - ```eidas.ms.auth.eIDAS.zmrclient.ssl.trustStore.password```
     - ```eidas.ms.auth.eIDAS.zmrclient.timeout.connection```
     - ```eidas.ms.auth.eIDAS.zmrclient.timeout.response```
     - ```eidas.ms.auth.eIDAS.zmrclient.req.update.reason.code```
     - ```eidas.ms.auth.eIDAS.zmrclient.req.update.reason.text```
     - ```eidas.ms.auth.eIDAS.zmrclient.debug.logfullmessages```
   - *ERnP Client*
     * ```eidas.ms.client.http.connection.timeout.request```
     * ```eidas.ms.client.http.connection.timeout.socket```

7. Registrierung am ID Austria System  

   Eine mögliche Matching Variante stellt das Matching über einen bestehenden ID Austria dar. Hierfür ist eine Registrierung am ID Austria System erforderlich. Aus Sicht des MS-Connectors sind folgende Registrierungsparameter auf jeden Fall notwendig:

   - Eindeutige Identifier: 

     - P-Stage: https://eidas.bmi.gv.at/ms_connector/sp/idaustria/metadata
     - T-Stage: https://eidas-test.bmi.gv.at/ms_connector/sp/idaustria/metadata

   - bPK-Berech: **ZP**

   - Attribute:

     - Ausstellungsland
     - Vorname (wird für öffentliche SP's per Default übertragen)
     - Familienname (wird für öffentliche SP's per Default übertragen)
     - Geburtsdatum (wird für öffentliche SP's per Default übertragen)
     - bPK (wird per Default übertragen)
     - Authentifizierungslevel des Bürgers  (wird per Default übertragen)

   - SAML2 Metadaten

     Die für die Registrierung benötigten SAML2 Metadaten werden automatisch generiert und  können unter den folgenden Endpunkten abgerufen werden.

     - P-Stage: https://eidas.bmi.gv.at/ms_connector/sp/idaustria/metadata
     - T-Stage: https://eidas-test.bmi.gv.at/ms_connector/sp/idaustria/metadata

   

